from math import *
import numpy as np
import numpy.linalg as nl
from splitstring import *
from calc_p_from_t import *
from calc_t_from_p import *

def CheckStr(str):
    ck = False
    if len(str) > 0:
        if str[0] == '/':
            ck = True
    return ck

#
#       Prepare the input data file
#
s_in = input("Input data file = ")
f_in = open(s_in, "r")
#
#       Set the contents of the input data file in the object data 
#
data_f = f_in.readlines()
f_in.close()

#
#       Prepare the output file
#
s_out = input("Output data file = ")
f_out = open(s_out, "w")
f_out.write("Input data file = " + s_in + "\n\n")

pos = 0
while not CheckStr(data_f[pos]):
    print(data_f[pos])
    pos += 1

pos += 1

splitStr = CSplit(' ', '\t', '\n')
splitStr.set_string(data_f[pos])
p = int(splitStr.seek_nonempty(0))
print("Number of independent variables, p = {}\n".format(p))
p += 1
pos += 1
splitStr.set_string(data_f[pos])
YLabel = splitStr.seek_nonempty(0)
XLabel = ['(Const)']
for i in range(1, p):
    XLabel.append(splitStr.seek_nonempty(i))

f_out.write('\nLabels...\n')
f_out.write('Y:  {}\n'.format(YLabel))
for i in range(p):
    f_out.write('X[{0}]: {1}\n'.format(i, XLabel[i]))


y = []
x = []
n = 0
pos += 1
while not CheckStr(data_f[pos]):
    splitStr.set_string(data_f[pos])
    y.append(float(splitStr.seek_nonempty(0)))
    x.append([1])
    for j in range(1, p):
        x[n].append(float(splitStr.seek_nonempty(j)))
    n += 1
    pos += 1

Y = np.matrix(y)
Y = np.transpose(Y)
X = np.matrix(x)
f_out.write(" ")
f_out.write("Input data...\n")
for i in range(n):
    f_out.write("{0:10}".format(Y[i,0]))
    for j in range(1, p):
        f_out.write("{0:7}".format(X[i, j]))
    f_out.write('\n')

XpXinv = nl.inv(np.transpose(X) * X)
b = XpXinv * np.transpose(X) * Y
f_out.write('\n')
for j in range(p):
    f_out.write("b[{0}]<{1}> = {2:.7f}\n".format(j, XLabel[j], b[j, 0]))

f_out.write('\n')
eq_str = YLabel + " = " + ("{0:.7f}".format(b[0, 0]))
for j in range(1, p):
    eq_str += " + " + "{0:.7f} * {1}".format(b[j, 0], XLabel[j])
eq_str += " + Residual"
f_out.write(eq_str + '\n')

sumY = 0.0
for i in range(n):
    sumY += Y[i, 0]
meanY = sumY / n
Yhat = X * b
SSReg = 0.0
SSTot = 0.0
for i in range(n):
    SSReg += (Yhat[i, 0] - meanY) ** 2.0
    SSTot += (Y[i, 0] - meanY) ** 2.0

R2 = SSReg / SSTot
R  = sqrt(R2)
f_out.write('\nR2 = {0:.7}\n'.format(R2))
f_out.write('R  = {0:.7}\n'.format(R))

SSE = np.transpose(Y - X * b) * (Y - X * b)
MSE = SSE[0, 0] / (n - p)
s2_b = MSE * XpXinv
t = []
for j in range(p):
    t.append(b[j, 0] / sqrt(s2_b[j,j]))

calc_p = C_cum_t(n - p)
p_v = []
for j in range(p):
    tp = calc_p.v(t[j])
    if tp < 0.5:
        p_v.append(2.0 * tp)
    else:
        p_v.append(2.0 * (1.0 - tp))
            
f_out.write('\n')
for j in range(p):
    f_out.write('b[{0}]<{1}>:\n      t = {2:.7f}   df = {3}   p-value = {4:.7f}\n'.\
                format(j, XLabel[j], t[j], n - p, p_v[j]))

calc_t = CCalc_t(n - p) 
t_a2 = calc_t.v(1.0 - 0.025)
L_Int = []
U_Int = []
for j in range(p):
    L_Int.append(b[j, 0] - sqrt(s2_b[j, j]) * t_a2)
    U_Int.append(b[j, 0] + sqrt(s2_b[j, j]) * t_a2)
f_out.write('\n')
f_out.write('95% Confidence Intervals:\n')
for j in range(p):
    f_out.write('b[{0}]<{1}>:\n             [{2:.5f}, {3:.5f}]\n'.\
                format(j, XLabel[j], L_Int[j], U_Int[j]))

    

f_out.close()

